package com.io.yutian.elementoriginlib.datasync;

public enum SyncResult {

    SUCCESS("同步成功", false),
    REDIS_CONNECTION_FAILED("Redis连接失败", true),
    MONGO_CONNECTION_FAILED("MongoDB连接失败", true),
    LOCK_FAILED("获取锁失败", true),
    NOT_FOUND_KEY("Redis键不存在", false),
    MONGO_DATA_NOT_FOUND("MongoDB数据不存在", false),
    EMPTY_DATA("Redis数据为空", false),
    REDIS_ERROR("Redis操作异常", true),
    MONGO_ERROR("MongoDB操作异常", true),
    INVALID_PARAMETERS("参数无效", true),
    UNKNOWN_ERROR("未知错误", true);

    private final String message;
    private final boolean error;

    SyncResult(String message, boolean isError) {
        this.message = message;
        this.error = isError;
    }

    public String getMessage() {
        return message;
    }

    public boolean isError() {
        return error;
    }

}
