package com.io.yutian.elementoriginlib.gui;

import com.io.yutian.elementoriginlib.util.ItemStackBuilder;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.event.ClickEvent;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryCloseEvent;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class DebugGui extends Gui {

    private Set<Integer> cachedSlots = new HashSet<>();

    public DebugGui(Player player, int size) {
        super(player, Component.text("Debug Gui"), size);
    }

    @Override
    public void init() {
    }

    @Override
    public void close(InventoryCloseEvent event) {
        StringBuilder sb = new StringBuilder();
        int i = 0;
        List<Integer> list = new ArrayList<>(cachedSlots);
        list.sort(Integer::compareTo);
        for (int slot : list) {
            sb.append(slot);
            if (i < list.size() - 1) {
                sb.append(", ");
            }
            i++;
        }
        player.sendMessage(Component.text("§b["+sb.toString()+"]").clickEvent(ClickEvent.clickEvent(ClickEvent.Action.COPY_TO_CLIPBOARD, sb.toString())).hoverEvent(Component.text("§f§l[点击复制]")));
    }

    @Override
    public void handler(Player player, int slot, InventoryClickEvent event) {
        if (slot < inventory.getSize()) {
            if (!cachedSlots.contains(slot)) {
                cachedSlots.add(slot);
                inventory.setItem(slot, new ItemStackBuilder(Material.SLIME_BALL).setDisplayName(" ").setDisplayName("§a"+slot).build());
            }
            event.setCancelled(true);
        }
    }

}
