package com.io.yutian.elementoriginlib.item;

import com.io.yutian.elementoriginlib.tag.ItemProxy;
import com.io.yutian.elementoriginlib.tag.TagCompound;
import org.bukkit.inventory.ItemStack;
import org.jetbrains.annotations.NotNull;

import java.util.function.Consumer;

public class TagStatItemStackBuilder {

    private final TagStatItem tagStatItem;

    protected ItemStack itemStack;

    protected ItemProxy itemProxy;

    public TagStatItemStackBuilder(TagStatItem tagStatItem) {
        this.tagStatItem = tagStatItem;
        this.itemStack = tagStatItem.getItemStack();
        this.itemProxy = tagStatItem.getItemProxy();
    }

    public void editTag(Consumer<TagCompound> tagCompoundConsumer) {
        itemProxy.editTag(tagCompoundConsumer);
    }

    @NotNull
    public ItemStack build() {
        buildCompounds();
        return itemStack;
    }

    private void buildCompounds() {
        tagStatItem.getStats().forEach((stat, statData) -> stat.whenApplied(this, statData));
        itemStack = itemProxy.getItemStack();
        tagStatItem.getStats().forEach((stat, statData) -> stat.applyMeta(this, statData));
    }

    @NotNull
    public ItemProxy getItemProxy() {
        return itemProxy;
    }

    public ItemStack getItemStack() {
        return itemStack;
    }

    public TagStatItem getOriginItem() {
        return tagStatItem;
    }

}
