package com.io.yutian.elementoriginlib.item.stat.type;

import com.io.yutian.elementoriginlib.item.TagStatItemStackBuilder;
import com.io.yutian.elementoriginlib.item.stat.ItemStat;
import com.io.yutian.elementoriginlib.item.stat.data.DoubleListData;
import com.io.yutian.elementoriginlib.tag.ItemProxy;
import com.io.yutian.elementoriginlib.tag.TagDouble;
import com.io.yutian.elementoriginlib.tag.TagList;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.ArrayList;
import java.util.List;

public abstract class DoubleListStat extends ItemStat<DoubleListData> {

    public DoubleListStat(@NotNull String id, @NotNull String path) {
        super(id, path);
    }

    @Override
    public void whenApplied(@NotNull TagStatItemStackBuilder itemStackBuilder, @NotNull DoubleListData statData) {
        ItemProxy itemProxy = itemStackBuilder.getItemProxy();
        TagList<TagDouble> tagList = new TagList<>();
        statData.getList().forEach(s -> tagList.add(new TagDouble(s)));
        itemProxy.editTag(tagCompound1 -> tagCompound1.put(getTagPath(), tagList));
    }

    @Nullable
    @Override
    public DoubleListData getLoadedTag(@NotNull ItemProxy itemProxy) {
        if (!itemProxy.has(getTagPath(), TagList.TYPE_ID)) {
            return new DoubleListData(new ArrayList<>());
        }
        TagList<TagDouble> tagList = (TagList<TagDouble>) itemProxy.get(getTagPath());
        List<Double> list = new ArrayList<>();
        for (int i = 0; i < tagList.size(); i++) {
            list.add(tagList.get(i).getDouble());
        }
        return new DoubleListData(list);
    }

}
