package com.io.yutian.elementoriginlib.mongodb;

import com.io.yutian.elementoriginlib.ElementOriginLib;
import com.io.yutian.elementoriginlib.config.MongodbConfig;

import java.util.HashMap;
import java.util.Map;

public class MongoDBFactory {

    private static Map<String, MongoDBIO> mongoDBIOs = new HashMap<>();

    public static MongoDBIO getMongoDBIO(String dbName) {
        return getMongoDBIO(ElementOriginLib.inst().getMongodbConfig(), dbName);
    }

    public static MongoDBIO getMongoDBIO(MongodbConfig config, String dbName) {
        MongoDBIO mongoDBIO = mongoDBIOs.get(dbName);
        if (mongoDBIO == null) {
            mongoDBIO = new MongoDBIO(config.getHost(), config.getPort(), config.getUsername(), config.getPassword(), dbName);
            mongoDBIOs.put(dbName, mongoDBIO);
        }
        return mongoDBIO;
    }

}
