package com.io.yutian.elementoriginlib.mongodb;

import com.mongodb.BasicDBObject;

public class UpdateEntity {
	private BasicDBObject incObjects = new BasicDBObject();
	private BasicDBObject setObjects = new BasicDBObject();
	private BasicDBObject unsetObjects = new BasicDBObject();

	public UpdateEntity() {
	}

	public UpdateEntity(BasicDBObject set) {
		this.setObjects = set;
	}

	public UpdateEntity set(String key, Object value) {
		setObjects.append(key, value);
		return this;
	}
	
	public UpdateEntity unset(String key) {
		unsetObjects.append(key, 0);
		return this;
	}

	public UpdateEntity inc(String key, int value) {
		incObjects.append(key, value);
		return this;
	}

	public BasicDBObject set() {
		return setObjects;
	}
	
	public BasicDBObject unset() {
		return unsetObjects;
	}

	public BasicDBObject inc() {
		return incObjects;
	}

	public void reset() {
		setObjects.clear();
		incObjects.clear();
		unsetObjects.clear();
	}
}
