package com.io.yutian.elementoriginlib.util;

import java.util.List;
import java.util.function.Predicate;

public class Util {

    public static <T> Predicate<T> allOf(List<? extends Predicate<T>> predicates) {
        List<Predicate<T>> list = List.copyOf(predicates);

        return switch (list.size()) {
            case 0 -> object -> true;
            case 1 -> list.get(0);
            case 2 -> list.get(0).and(list.get(1));
            default -> object -> {
                for (Predicate<T> predicate : list) {
                    if (!predicate.test(object)) {
                        return false;
                    }
                }
                return true;
            };
        };
    }

}
